package com.jeeplus.modules.sg.financial.erpcredit.entity;

import com.jeeplus.common.utils.excel.annotation.ExcelField;
import com.jeeplus.core.persistence.DataEntity;

import java.util.ArrayList;
import java.util.List;

public class ErpCredit extends DataEntity<ErpCredit>{
    private static final long serialVersionUID = 1L;

    private String itemId;//项目定义编码
    private String itemName;//项目名称
    private Double actualInvestment;//实际投资
    private Double transferAssets;//移交生产的资产总值
    private Double consBuildingFee;//施工：建筑费
    private Double consInstallFee;//施工：安装费
    private Double consTotalFee;//施工：总计
    private Double otherSupervisorFee;//其他：监理费
    private Double otherDesignFee;//其他设计费
    private Double otherBeWorkFee;//项目前期工作费
    private Double otherBuildLoan;//建设期贷款利息
    private Double otherLineDamages;//线路施工赔偿费
    private Double otherLegalManage;//法人管理费
    private Double otherTotalFee;//其他费用合计
    private Double theInputTax;//进项税额
    private String tenKvModel;//架空导线型号
    private String tenKvUnit;//10kv线路信息单位
    private Double tenKvLength;//10kv线路信息长度
    private Double tenKvLineLength;//10kv线路长度km
    private Double tenKvItsLine;//10kv线路其中
    private Double tenKvItesFhvFollow;//400v以下
    private String supplierName;//供应商名称
    private String cableTube;//电缆管信息
    private String status;//状态
    private List<ErpCreditEquipment> erpCreditChild1s = new ArrayList<ErpCreditEquipment>();
    private List<ErpCreditMaterial> erpCreditChild2s = new ArrayList<ErpCreditMaterial>();

    public String getStatus() {
        return status;
    }

    public void setStatus(String status) {
        this.status = status;
    }

    public static long getSerialVersionUID() {
        return serialVersionUID;
    }
    @ExcelField(title="项目定义编号", align=2, sort=1)
    public String getItemId() {
        return itemId;
    }

    public void setItemId(String itemId) {
        this.itemId = itemId;
    }
    @ExcelField(title="项目名称", align=2, sort=2)
    public String getItemName() {
        return itemName;
    }

    public void setItemName(String itemName) {
        this.itemName = itemName;
    }
    @ExcelField(title="实际投资", align=2, sort=3)
    public Double getActualInvestment() {
        return actualInvestment;
    }

    public void setActualInvestment(Double actualInvestment) {
        this.actualInvestment = actualInvestment;
    }

    public Double getTransferAssets() {
        return transferAssets;
    }

    public void setTransferAssets(Double transferAssets) {
        this.transferAssets = transferAssets;
    }

    public Double getConsBuildingFee() {
        return consBuildingFee;
    }

    public void setConsBuildingFee(Double consBuildingFee) {
        this.consBuildingFee = consBuildingFee;
    }

    public Double getConsInstallFee() {
        return consInstallFee;
    }

    public void setConsInstallFee(Double consInstallFee) {
        this.consInstallFee = consInstallFee;
    }

    public Double getConsTotalFee() {
        return consTotalFee;
    }

    public void setConsTotalFee(Double consTotalFee) {
        this.consTotalFee = consTotalFee;
    }

    public Double getOtherSupervisorFee() {
        return otherSupervisorFee;
    }

    public void setOtherSupervisorFee(Double otherSupervisorFee) {
        this.otherSupervisorFee = otherSupervisorFee;
    }

    public Double getOtherDesignFee() {
        return otherDesignFee;
    }

    public void setOtherDesignFee(Double otherDesignFee) {
        this.otherDesignFee = otherDesignFee;
    }

    public Double getOtherBeWorkFee() {
        return otherBeWorkFee;
    }

    public void setOtherBeWorkFee(Double otherBeWorkFee) {
        this.otherBeWorkFee = otherBeWorkFee;
    }

    public Double getOtherBuildLoan() {
        return otherBuildLoan;
    }

    public void setOtherBuildLoan(Double otherBuildLoan) {
        this.otherBuildLoan = otherBuildLoan;
    }

    public Double getOtherLineDamages() {
        return otherLineDamages;
    }

    public void setOtherLineDamages(Double otherLineDamages) {
        this.otherLineDamages = otherLineDamages;
    }

    public Double getOtherLegalManage() {
        return otherLegalManage;
    }

    public void setOtherLegalManage(Double otherLegalManage) {
        this.otherLegalManage = otherLegalManage;
    }

    public Double getOtherTotalFee() {
        return otherTotalFee;
    }

    public void setOtherTotalFee(Double otherTotalFee) {
        this.otherTotalFee = otherTotalFee;
    }

    public Double getTheInputTax() {
        return theInputTax;
    }

    public void setTheInputTax(Double theInputTax) {
        this.theInputTax = theInputTax;
    }

    public String getTenKvModel() {
        return tenKvModel;
    }

    public void setTenKvModel(String tenKvModel) {
        this.tenKvModel = tenKvModel;
    }

    public String getTenKvUnit() {
        return tenKvUnit;
    }

    public void setTenKvUnit(String tenKvUnit) {
        this.tenKvUnit = tenKvUnit;
    }

    public Double getTenKvLength() {
        return tenKvLength;
    }

    public void setTenKvLength(Double tenKvLength) {
        this.tenKvLength = tenKvLength;
    }

    public Double getTenKvLineLength() {
        return tenKvLineLength;
    }

    public void setTenKvLineLength(Double tenKvLineLength) {
        this.tenKvLineLength = tenKvLineLength;
    }

    public Double getTenKvItsLine() {
        return tenKvItsLine;
    }

    public void setTenKvItsLine(Double tenKvItsLine) {
        this.tenKvItsLine = tenKvItsLine;
    }

    public Double getTenKvItesFhvFollow() {
        return tenKvItesFhvFollow;
    }

    public void setTenKvItesFhvFollow(Double tenKvItesFhvFollow) {
        this.tenKvItesFhvFollow = tenKvItesFhvFollow;
    }

    public String getSupplierName() {
        return supplierName;
    }

    public void setSupplierName(String supplierName) {
        this.supplierName = supplierName;
    }

    public String getCableTube() {
        return cableTube;
    }

    public void setCableTube(String cableTube) {
        this.cableTube = cableTube;
    }

    public List<ErpCreditEquipment> getErpCreditChild1s() {
        return erpCreditChild1s;
    }

    public void setErpCreditChild1s(List<ErpCreditEquipment> erpCreditChild1s) {
        this.erpCreditChild1s = erpCreditChild1s;
    }

    public List<ErpCreditMaterial> getErpCreditChild2s() {
        return erpCreditChild2s;
    }

    public void setErpCreditChild2s(List<ErpCreditMaterial> erpCreditChild2s) {
        this.erpCreditChild2s = erpCreditChild2s;
    }

    @Override
    public String toString() {
        return "ErpCredit{" +
                "itemId='" + itemId + '\'' +
                ", itemName='" + itemName + '\'' +
                ", actualInvestment=" + actualInvestment +
                ", transferAssets=" + transferAssets +
                ", consBuildingFee=" + consBuildingFee +
                ", consInstallFee=" + consInstallFee +
                ", consTotalFee=" + consTotalFee +
                ", otherSupervisorFee=" + otherSupervisorFee +
                ", otherDesignFee=" + otherDesignFee +
                ", otherBeWorkFee=" + otherBeWorkFee +
                ", otherBuildLoan=" + otherBuildLoan +
                ", otherLineDamages=" + otherLineDamages +
                ", otherLegalManage=" + otherLegalManage +
                ", otherTotalFee=" + otherTotalFee +
                ", theInputTax=" + theInputTax +
                ", tenKvModel='" + tenKvModel + '\'' +
                ", tenKvUnit='" + tenKvUnit + '\'' +
                ", tenKvLength=" + tenKvLength +
                ", tenKvLineLength=" + tenKvLineLength +
                ", tenKvItsLine=" + tenKvItsLine +
                ", tenKvItesFhvFollow=" + tenKvItesFhvFollow +
                ", supplierName='" + supplierName + '\'' +
                ", cableTube='" + cableTube + '\'' +
                ", status='" + status + '\'' +
                ", erpCreditChild1s=" + erpCreditChild1s +
                ", erpCreditChild2s=" + erpCreditChild2s +
                '}';
    }
}
