package com.jeeplus.modules.sg.financial.erpcredit.util;

import com.jeeplus.modules.sg.financial.erpcredit.entity.*;
import com.jeeplus.modules.sg.financial.settlement.entity.MaintainData;

import java.text.DecimalFormat;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.TreeSet;

/**
 * 导出数据计算类
 */
public class ExportUtil1{
    public static String POWER_DEPARTMENT="配电检修工区";
    public static String POWER_BDZ="变压器";
    public static String POWER_BOXBDZ="箱式变电站";
    public static String POWER_HGW="环网";
    public static String POWER_KGG="高压开关柜";
    public static String POWER_ZYXL="中压线路";
    public static String POWER_BDZCOUNT="160200001";
    public static String POWER_BOXCOUNT="160200002";
    public static String POWER_HGWCOUNT="160200003";
    public static String POWER_KGGCOUNT="160200010";
    public static String POWER_HJ="合计";

    /**
     * 一览表汇总
     * @param erpCreditList
     * @param maintainDataList
     * @return
     */
    public static List<Schedule> getScheduleList(List<ErpCredit> erpCreditList, List<MaintainData> maintainDataList){
        DecimalFormat decimalFormat   = new DecimalFormat("#0.00");
        String itemNameAll="合计";//工程名称
        Double budgetBuildProjectAll=0.0;//预算建筑工程
        Double budgetInstallProjectAll=0.0;//预算安装工程
        Double budgetEquipmentValueAll=0.0;//预算设备价值
        Double budgetOtherFeeAll=0.0;//预算其他费用
        Double budgetTotalFeeAll=0.0;//预算合计金额
        Double actualBuildProjectAll=0.0;//实际金额建筑工程
        Double actualIntallProjectAll=0.0;//实际安装工程
        Double actualEquipmentValueAll=0.0;//实际设备价值
        Double actualOtherFeeAll=0.0;//实际其他费用
        Double actualTotalFeeAll=0.0;//实际合计
        Double addSubtractionLinesAll=0.0;//增加额
        Double addSubtractionRateAll=0.0;//增加率
        Schedule scheduletotal = new Schedule();
        List<Schedule> schedules = new ArrayList<Schedule>();
        Schedule schedule = null;
        if (null!=erpCreditList&&erpCreditList.size()>0){
            for (ErpCredit erpCredit:erpCreditList){
                schedule = new Schedule();
                schedule = getActualRelative(schedule,erpCredit,maintainDataList);//得到一览表实际金额
                schedules.add(schedule);
            }
        }
        for (Schedule s:schedules){
            if (null!=s.getBudgetBuildProject()){
                budgetBuildProjectAll+=Double.parseDouble(s.getBudgetBuildProject());
                scheduletotal.setBudgetBuildProject(decimalFormat.format(budgetBuildProjectAll));
            }
            if (null!=s.getBudgetTotalFee()){
                budgetInstallProjectAll+=Double.parseDouble(s.getBudgetTotalFee());
                scheduletotal.setBudgetInstallProject(decimalFormat.format(budgetInstallProjectAll));
            }
            if (null!=s.getBudgetEquipmentValue()){
                budgetEquipmentValueAll+=Double.parseDouble(s.getBudgetEquipmentValue());
                scheduletotal.setBudgetEquipmentValue(decimalFormat.format(budgetEquipmentValueAll));
            }
            if (null!=s.getBudgetOtherFee()){
                budgetOtherFeeAll+=Double.parseDouble(s.getBudgetOtherFee());
                scheduletotal.setBudgetOtherFee(decimalFormat.format(budgetOtherFeeAll));
            }
            if (null!=s.getBudgetTotalFee()){
                budgetTotalFeeAll+=Double.parseDouble(s.getBudgetTotalFee());
                scheduletotal.setBudgetTotalFee(decimalFormat.format(budgetTotalFeeAll));
            }
            if (null!=s.getActualBuildProject()){
                actualBuildProjectAll+=Double.parseDouble(s.getActualBuildProject());
                scheduletotal.setActualBuildProject(decimalFormat.format(actualBuildProjectAll));
            }
            if (null!=s.getActualIntallProject()){
                actualIntallProjectAll+=Double.parseDouble(s.getActualIntallProject());
                scheduletotal.setActualIntallProject(decimalFormat.format(actualIntallProjectAll));
            }
            if (null!=s.getActualEquipmentValue()){
                actualEquipmentValueAll+=Double.parseDouble(s.getActualEquipmentValue());
                scheduletotal.setActualEquipmentValue(decimalFormat.format(actualEquipmentValueAll));
            }
            if (null!=s.getActualOtherFee()){
                actualOtherFeeAll+=Double.parseDouble(s.getActualOtherFee());
                scheduletotal.setActualOtherFee(decimalFormat.format(actualOtherFeeAll));
            }
            if (null!=s.getActualTotalFee()){
                actualTotalFeeAll+=Double.parseDouble(s.getActualTotalFee());
                scheduletotal.setActualTotalFee(decimalFormat.format(actualTotalFeeAll));
            }
            if (null!=s.getAddSubtractionLines()){
                addSubtractionLinesAll+=Double.parseDouble(s.getAddSubtractionLines());
                scheduletotal.setAddSubtractionLines(decimalFormat.format(addSubtractionLinesAll));
            }
            if (null!=s.getAddSubtractionRate()){
                addSubtractionRateAll+=Double.parseDouble(s.getAddSubtractionRate());
                scheduletotal.setAddSubtractionRate(decimalFormat.format(addSubtractionRateAll));
            }
        }
        scheduletotal.setItemName(itemNameAll);
        schedules.add(scheduletotal);
        return schedules;
    }
    //一览表 实际较预算增减
    public static Schedule getActualRelative(Schedule schedule, ErpCredit erpCredit, List<MaintainData> maintainDataList){
        DecimalFormat decimalFormat   = new DecimalFormat("#0.00");
        Schedule scheduleBudget = getScheduleBudget(schedule,erpCredit,maintainDataList);//得到预算合计费用
        Schedule scheduleActual = getScheduleActual(scheduleBudget,erpCredit);//得到实际费用
        double addSubtractionLines = 0.0;//增加额
        double addSubtractionRate1=0.0;//增减去率
        //判断为空的条件
        //如果实际合计金额为空 赋予初始值为0
        if (null==schedule.getActualTotalFee()) {
            schedule.setActualTotalFee("0");
        }
        //如果预算合计金额为空，赋予初始值0
        if (null==schedule.getBudgetTotalFee()){
            schedule.setBudgetTotalFee("0");
        }
        //增加率
        addSubtractionLines=Double.parseDouble(schedule.getActualTotalFee())-Double.parseDouble(schedule.getBudgetTotalFee());
        schedule.setAddSubtractionLines(decimalFormat.format(addSubtractionLines));//添加入郑家率
        if (null==schedule.getBudgetTotalFee()) {//如果预算价值为空，赋初始值为1；
            schedule.setAddSubtractionLines("1");
        }
        //计算增减率
        addSubtractionRate1 = addSubtractionLines/Double.parseDouble(schedule.getBudgetTotalFee())*100;
        schedule.setAddSubtractionRate(decimalFormat.format(addSubtractionRate1));
        return scheduleActual;
    }
    //获取：一览表 预算价值
    public static Schedule getScheduleBudget(Schedule schedule, ErpCredit erpCredit, List<MaintainData> maintainDataList){
        DecimalFormat decimalFormat   = new DecimalFormat("#0.00");
        if (null!=maintainDataList&&maintainDataList.size()>0){
            for (MaintainData maintainData:maintainDataList){
                //判断id是否一样
                if (maintainData.getProjectId().equals(erpCredit.getItemId())){
                    schedule.setBudgetBuildProject(decimalFormat.format(maintainData.getBuildingFee()));//建筑费
                    //安装供材 = 安装费+主材费
                    schedule.setBudgetInstallProject(decimalFormat.format(maintainData.getInstallFee()+maintainData.getMaterialFee()));
                    schedule.setBudgetEquipmentValue(decimalFormat.format(maintainData.getEquipmentFee()));//设备购置费
                    //其他费用合计
                    schedule.setBudgetOtherFee(decimalFormat.format(maintainData.getDesignFee()+maintainData.getSupervisionFee()+maintainData.getPreliminaryWorkFee()
                            +maintainData.getDamages()+maintainData.getManagementFee()));
                    //预算合计费用
                    schedule.setBudgetTotalFee(decimalFormat.format(maintainData.getBuildingFee()+maintainData.getInstallFee()
                            +maintainData.getMaterialFee()+maintainData.getEquipmentFee()+maintainData.getDesignFee()+maintainData.getSupervisionFee()+maintainData.getPreliminaryWorkFee()
                            +maintainData.getDamages()+maintainData.getManagementFee()));
                }
            }
        }
        return schedule;
    }
    //计算一览表合计

    //获取：一览表 实际价值
    public static Schedule getScheduleActual(Schedule schedule, ErpCredit erpCredit){
        DecimalFormat decimalFormat   = new DecimalFormat("#0.00");
        boolean flag = false;
        List<ErpCreditMaterial> erpCreditChild2s = null;//得到材料费金额
        List<ErpCreditEquipment> erpCreditChild1s = null;//得到设备费金额
        double netAmount=0.0;//入账金额:设备费，材料费
        double actualTotalFee=0.0;//合计金额
        //循环erpCredit集合
        schedule.setItemId(erpCredit.getItemId());//得到项目定义编号
        schedule.setItemName(erpCredit.getItemName());//得到项目名称
        netAmount = getErpCreditMaterial(erpCredit);//得到材料费
        //设备费&&erpCredit.getTenKvModel()!=null
        if (null!=erpCredit.getConsInstallFee()){
            schedule.setActualIntallProject(decimalFormat.format(netAmount+erpCredit.getConsInstallFee()));
            actualTotalFee=actualTotalFee+netAmount+erpCredit.getConsInstallFee();//合计金额累加
        }
        if (null!=erpCredit.getConsBuildingFee()){//如果建筑费不为空
            //得到实际建筑工程
            schedule.setActualBuildProject(decimalFormat.format(erpCredit.getConsBuildingFee()+netAmount));
            actualTotalFee+=erpCredit.getConsBuildingFee()+netAmount;//合计金额加上
        }
        netAmount = 0.0;
        erpCreditChild1s = erpCredit.getErpCreditChild1s();//得到设备费
        //判断设备费
        if (null!=erpCreditChild1s&&erpCreditChild1s.size()>0){
            for (ErpCreditEquipment erpCreditChild1:erpCreditChild1s){
                if (null!=erpCreditChild1.getEqmBookedFee1()){
                    netAmount+=erpCreditChild1.getEqmBookedFee1();//得到设备费累加（设备价值）
                    flag=true;
                }
            }
            if (flag){
                schedule.setActualEquipmentValue(decimalFormat.format(netAmount));//实际设备价值
                actualTotalFee+=netAmount;//实际费用累加
//                if (null!=erpCredit.getConsInstallFee()){
//                   if (null==erpCredit.getTenKvModel()){
//                       schedule.setActualEquipmentValue(decimalFormat.format(netAmount+erpCredit.getConsInstallFee()));//实际设备价值
//                       actualTotalFee+=netAmount+erpCredit.getConsInstallFee();//实际费用累加
//                   }else {
//                       schedule.setActualEquipmentValue(decimalFormat.format(netAmount));//实际设备价值
//                       actualTotalFee+=netAmount;//实际费用累加
//                   }
//                }
            }
            flag=false;//数据清0
            netAmount=0.0;
        }
        //得到其他费用合计
        if (null!=erpCredit.getOtherTotalFee()){//得到其他费用
            schedule.setActualOtherFee(decimalFormat.format(erpCredit.getOtherTotalFee()));
            actualTotalFee+=erpCredit.getOtherTotalFee();//合计金额累加
        }
        //添加合计金额
        schedule.setActualTotalFee(decimalFormat.format(actualTotalFee));//写入合计金额
        return schedule;
    }

    /**
     * 其他费用明细表 实际费用
     * @param erpCreditList
     * @return
     */
    public static ScheduleOther getScheduleOfOtherExpenses(List<ErpCredit> erpCreditList){
        DecimalFormat decimalFormat   = new DecimalFormat("#0.00");
        ScheduleOther scheduleOther = new ScheduleOther();
        Double requisitionSite=0.0;//建设场地征用及清理费
        Double  compensationAcquisition=0.0;//土地征用补偿费
        Double compensateFee=0.0;//土地征用补偿费（赔青费）
        Double  managementFee=0.0;//项目建设管理费
        Double  preWorkingFee=0.0;//项目前期工作费
        Double  itemManageFee=0.0;//项目管理经费
        Double  supervisionFee=0.0;//工程监理费
        Double   technicalFee=0.0;//项目建设技术服务费
        Double  surveyFee=0.0;//工程勘察费
        Double  designFee=0.0;//工程设计费
        Double  economicFee=0.0;//技术经济标准变值管理费
        Double  inspectionFee=0.0;//工程建设监督检测费
        Double  preparationFee=0.0;//生产准备费
        Double  basicFee=0.0;//基本预备费
        Double  reserveFee=0.0;//资本化利息
        Double  totalFee=0.0;//合计
        if (null!=erpCreditList&&erpCreditList.size()>0){
            for (ErpCredit erpCredit:erpCreditList){
                //如果线路施工赔偿费不等于空，土地征用补偿费累加
                if (null!=erpCredit.getOtherLineDamages()){
                    compensateFee+=erpCredit.getOtherLineDamages();//赔青费
                }
                //前期工作费合计
                if (null!=erpCredit.getOtherBeWorkFee()){
                    preWorkingFee+=erpCredit.getOtherBeWorkFee();
                }
                //如果法人管理费不为空，则赋值项目管理经费
                if (null!=erpCredit.getOtherLegalManage()){
                    itemManageFee+=erpCredit.getOtherLegalManage();//项目管理经费
                }
                //如果监理费不为空，则赋值为工程监理费
                if (null!=erpCredit.getOtherSupervisorFee()){
                    supervisionFee+=erpCredit.getOtherSupervisorFee();
                }
                //如果设计费不为空，则赋值为工程设计费
                if (null!=erpCredit.getOtherDesignFee()){
                    designFee+=erpCredit.getOtherDesignFee();
                }
                //如果=ERP账生成数据中建设期贷款利息不为空，则累计赋值到资本化利息
                if (null!= erpCredit.getOtherBuildLoan()){
                    reserveFee+=erpCredit.getOtherBuildLoan();
                }
            }
        }
        //项目建设技术服务费（暂无）
        technicalFee=designFee;
        //项目建设管理费
        managementFee=itemManageFee+supervisionFee+preWorkingFee;
        //建设场地征用费
        requisitionSite=compensationAcquisition+compensateFee;
        //合计
        totalFee=requisitionSite+managementFee+technicalFee+inspectionFee+preparationFee+basicFee+reserveFee+preWorkingFee;
        scheduleOther.setCompensateFee(decimalFormat.format(compensateFee));//土地征用补偿费
        scheduleOther.setItemManageFee(decimalFormat.format(itemManageFee));//项目管理经费
        scheduleOther.setSupervisionFee(decimalFormat.format(supervisionFee));//工程监理费
        scheduleOther.setDesignFee(decimalFormat.format(designFee));//工程设计费
        scheduleOther.setReserveFee(decimalFormat.format(reserveFee));//资本化利息
        scheduleOther.setTechnicalFee(decimalFormat.format(technicalFee));//项目设计技术服务费
        scheduleOther.setManagementFee(decimalFormat.format(managementFee));//项目建设管理费
        scheduleOther.setRequisitionSite(decimalFormat.format(requisitionSite));//建设场地征用费
        scheduleOther.setTotalFee(decimalFormat.format(totalFee));//合计
        return scheduleOther;
    }
    /**
     * 其他费用明细表 预算费用
     * @param
     * @return
     */
    public static ScheduleOther getScheduleOfOtherExpensesReg(List<MaintainData> maintainDataList){
        DecimalFormat decimalFormat   = new DecimalFormat("#0.00");
        Double requisitionSite=0.0;//建设场地征用及清理费
        ScheduleOther scheduleOther = new ScheduleOther();
        Double  cleaningFees=0.0;//余物清理费
        Double  managementFee=0.0;//项目建设管理费
        Double  preWorkingFee=0.0;//项目前期工作费
        Double  itemManageFee=0.0;//项目管理经费
        Double  supervisionFee=0.0;//工程监理费
        Double  designFee=0.0;//工程设计费
        Double  preparationFee=0.0;//生产准备费
        Double compensateFee=0.0;//土地征用补偿费（赔青费）
        Double  totalFee=0.0;//合计
        if (null!=maintainDataList&&maintainDataList.size()>0){
            for (MaintainData maintainData:maintainDataList){
                compensateFee+=maintainData.getDamages();
                cleaningFees+=maintainData.getDamages();//清理费
                preWorkingFee+=maintainData.getPreliminaryWorkFee();//项目前期工作费
                itemManageFee+=maintainData.getManagementFee();//法人管理经费
                supervisionFee+=maintainData.getSupervisionFee();//监理费
                designFee+=maintainData.getDesignFee();//工程设计费
            }
            //项目建设管理费
            managementFee = preWorkingFee+itemManageFee+supervisionFee;
            //合计金额
            totalFee=preWorkingFee+itemManageFee+supervisionFee+designFee+compensateFee;//合计金额
            scheduleOther.setPreWorkingFee(decimalFormat.format(preparationFee));//项目前期工作费合计
            scheduleOther.setItemManageFee(decimalFormat.format(itemManageFee));//法人管理经费
//            scheduleOther.setCleaningFees(decimalFormat.format(cleaningFees));//余物清理费
            scheduleOther.setSupervisionFee(decimalFormat.format(supervisionFee));//工程监理费
            scheduleOther.setDesignFee(decimalFormat.format(designFee));//工程设计费合计
            scheduleOther.setPreWorkingFee(decimalFormat.format(preparationFee));
            //合计金额
            scheduleOther.setTotalFee(decimalFormat.format(totalFee));//合计金额
            scheduleOther.setCompensateFee(decimalFormat.format(compensateFee));//赔青
            //项目建设管理费
            scheduleOther.setManagementFee(decimalFormat.format(managementFee));
            //工程建设服务费
            scheduleOther.setTechnicalFee(decimalFormat.format(designFee));
            scheduleOther.setRequisitionSite(decimalFormat.format(compensateFee));//建设场地征用及清理费
        }
        return scheduleOther;
    }

    /**
     * 设备材料清册
     * @param erpCredits
     * @return
     */
    public static List<MaterialEquipment> getMaterialEquipment(List<ErpCredit> erpCredits){
        DecimalFormat decimalFormat   = new DecimalFormat("#0.00");
        DecimalFormat decimalFormat1 = new DecimalFormat("#0");
        Double count = 0.0;
        List<MaterialEquipment> materialEquipments = new ArrayList<MaterialEquipment>();
        MaterialEquipment materialEquipment = null;
        List<ErpCreditEquipment> erpCreditChild1s = null;
        List<ErpCreditMaterial> erpCreditChild2s = null;
        for (ErpCredit erpCredit:erpCredits){
            erpCreditChild1s=erpCredit.getErpCreditChild1s();//获取设备费描述
            erpCreditChild2s=erpCredit.getErpCreditChild2s();//获取材料表描述
            //设备详情
            if (null!=erpCreditChild1s&&erpCreditChild1s.size()>0){
                for (ErpCreditEquipment erpCreditChild1:erpCreditChild1s){
                    count=0.0;
                    materialEquipment=new MaterialEquipment();
                    materialEquipment.setId(erpCredit.getItemId());//得到项目id
                    //物料描述赋值给名称
                    materialEquipment.setMeName(erpCreditChild1.getEqmMaterialDetails1());
                    //如果供应商不为空，赋值供应商
                    if (null!=erpCreditChild1.getEqmSupplierName()){
                        materialEquipment.setMeSupplierName(erpCreditChild1.getEqmSupplierName());
                    }
                    //得到单位
                    if (null!=erpCreditChild1.getEqmUnit()){
                        materialEquipment.setMeUnit(erpCreditChild1.getEqmUnit());
                    }
                    //得到数量
                    if (null!=erpCreditChild1.getEqmNumbers()){
                        materialEquipment.setMeNumber(String.valueOf(erpCreditChild1.getEqmNumbers()));
                    }
                    //得到合计金额
                    if (null!=erpCreditChild1.getEqmBookedFee1()){
                        materialEquipment.setMeAllPrice(String.valueOf(erpCreditChild1.getEqmBookedFee1()));
                        if (null!=materialEquipment.getMeNumber()){
                            count=erpCreditChild1.getEqmBookedFee1()/Double.parseDouble(materialEquipment.getMeNumber());
                            materialEquipment.setMeUnitPrice(decimalFormat.format(count));
                        }else {
                            materialEquipment.setMeUnitPrice(decimalFormat.format(erpCreditChild1.getEqmBookedFee1()));
                        }
                    }else {
                        materialEquipment.setMeAllPrice("0");
                    }
                    materialEquipments.add(materialEquipment);
                }
            }
            //材料详情
            if (null!=erpCreditChild2s&&erpCreditChild2s.size()>0){
                for (ErpCreditMaterial erpCreditChild2:erpCreditChild2s){
                    count=0.0;
                    materialEquipment=new MaterialEquipment();
                    //得到材料费项目定义号
                    materialEquipment.setId(erpCredit.getItemId());
                    //得到材料费名称
                    materialEquipment.setMeName(erpCreditChild2.getEqmMaterialDetails2());
                    //得到供应商
                    if (null!=erpCreditChild2.getMtlSupplierName()){
                        materialEquipment.setMeSupplierName(erpCreditChild2.getMtlSupplierName());
                    }
                    //得到单位
                    if (null!=erpCreditChild2.getMtlUnit()){
                        materialEquipment.setMeUnit(erpCreditChild2.getMtlUnit());
                    }
                    //得到数量
                    if (null!=erpCreditChild2.getMtlNumbers()){
                        materialEquipment.setMeNumber(String.valueOf(erpCreditChild2.getMtlNumbers()));
                    }
                    //得到合计金额
                    if (null!=erpCreditChild2.getMtlBookedFee2()){
                        materialEquipment.setMeAllPrice(String.valueOf(erpCreditChild2.getMtlBookedFee2()));
                        if (null!=materialEquipment.getMeNumber()){
                            count=erpCreditChild2.getMtlBookedFee2()/Double.parseDouble(materialEquipment.getMeNumber());
                            materialEquipment.setMeUnitPrice(decimalFormat.format(count));
                        }else {
                            materialEquipment.setMeUnitPrice(decimalFormat.format(erpCreditChild2.getMtlBookedFee2()));
                        }
                    }else {
                        materialEquipment.setMeUnit("");
                    }
                    materialEquipments.add(materialEquipment);
                }
            }
        }
        return materialEquipments;
    }

    /**
     * 移交资产—配电网资产一览表(线路)
     * @return
     */
    public static List<TransferOfPower1> getTransFerPower1(List<ErpCredit> erpCredits){
        DecimalFormat decimalFormat   = new DecimalFormat("#0.00");
        List<TransferOfPower1> transferOfPower1s = new ArrayList<TransferOfPower1>();//创建一个线路集合
        TransferOfPower1 transferOfPower1 = null;//定义线路对象
        List<ErpCreditEquipment> erpCreditChild1s = null;//定义设备对象

        Double materialTotal = 0.0;//材料费总计


        Double eqmNumbers = 0.0;//总容量 //分摊后安装费
        Double eqmBookedFee=0.0;//设备入账金额
        Double eqmValue = 0.0;//相同项目定义号合计
        Double standInFee=0.0;//摊入费用
        Double powerDeliveredAssets=0.0;//交付知产使用价值
        //合计
        Double powerTenKvLineLengthAll=0.0;//10kv线路长度
        Double buildFeeAll=0.0;//建筑费用合计
        Double installFeeAll=0.0;//安装费用合计
        Double standInFeeAll=0.0;//摊入费用合计
        Double powerDeliveredAssetsAll=0.0;//交付知产使用价值合计
        for (ErpCredit erpCredit:erpCredits){//循环erp账户项目
            materialTotal = 0.0;//材料费合计赋予初始值
            standInFee = 0.0;//摊入费用赋予初始值
            powerDeliveredAssets=0.0;//交付知产使用加赋予初始值
            erpCreditChild1s = erpCredit.getErpCreditChild1s();//获取设备集合
            materialTotal = getErpCreditMaterial(erpCredit);//得到材料费合计
            if (null!=erpCreditChild1s&&erpCreditChild1s.size()>=0){
                eqmNumbers = 0.0;//赋予初始值
                eqmValue = 0.0;//赋予初始值
                eqmBookedFee=0.0;//入账金额赋予初始值
                for (ErpCreditEquipment erpCreditChild11:erpCreditChild1s){//循环设备费
                    if (null!=erpCreditChild11.getEqmNumbers()){//当前项目定义号所有的台数合计
                        eqmNumbers+=erpCreditChild11.getEqmNumbers();
                    }
                    if (null!=erpCreditChild11.getEqmBookedFee1()){
                        eqmBookedFee+=erpCreditChild11.getEqmBookedFee1();//设备入账金额
                    }
                }
                if (null!=erpCredit.getConsInstallFee()){//得到分摊后安装费
                    eqmNumbers=erpCredit.getConsTotalFee()/eqmNumbers;
                }
                if (null==erpCredit.getTenKvModel()||erpCredit.getTenKvModel()==""){//若10KV电缆、架空导线型号为空：得到设备价值
                    eqmValue = eqmBookedFee + eqmNumbers + eqmValue;//设备H6的和
                }else {
                    eqmValue = eqmBookedFee;
                }
            }
            //添加固定数据:线路
            transferOfPower1  = new TransferOfPower1();//得到线路集合
            transferOfPower1.setPowerId(erpCredit.getItemId());//添加项目定义号
            transferOfPower1.setPowerName(erpCredit.getItemName());//添加项目名称
            transferOfPower1.setPowerArea("-");//添加其实地点和所在第
            transferOfPower1.setPowerNumberBars("1");
            transferOfPower1.setPowerAssetClass(POWER_ZYXL);//中亚线路
            transferOfPower1.setPowerDepartment(ExportUtil1.POWER_DEPARTMENT);//添加保管
            if (null!=erpCredit.getTenKvItsLine()) {//其中 10kv线路 10kv线路长度
                transferOfPower1.setPowerTenKvLineLength(decimalFormat.format(erpCredit.getTenKvItsLine()));//添加10kv线路
                powerTenKvLineLengthAll+=erpCredit.getTenKvItsLine();//交付使用资产价值
            }
            if (null!=erpCredit.getTenKvModel()){//10kv电缆架空导线型号
                transferOfPower1.setPowerTenKvCableType(erpCredit.getTenKvModel());
            }
            //添加保护管信息
            if (null!=erpCredit.getCableTube()){
                transferOfPower1.setPowerTenKvCableType(erpCredit.getCableTube());
            }
            if (null!=erpCredit.getConsBuildingFee()){//建筑费
                transferOfPower1.setPowerBuildFee(decimalFormat.format(erpCredit.getConsBuildingFee()+materialTotal));
                powerDeliveredAssets+=erpCredit.getConsBuildingFee()+materialTotal;//交付使用资产价值
                buildFeeAll+=erpCredit.getConsBuildingFee()+materialTotal;//建筑费用合计
            }
            if (null!=erpCredit.getConsInstallFee()&&erpCredit.getTenKvModel()!=null){//安装费
                transferOfPower1.setPowerInstallFee(decimalFormat.format(erpCredit.getConsInstallFee()+materialTotal));//添加安装费
                powerDeliveredAssets+=erpCredit.getConsInstallFee()+materialTotal;//交付使用资产价值
                installFeeAll+=erpCredit.getConsInstallFee()+materialTotal;//建筑费用合计
            }else {
                transferOfPower1.setPowerInstallFee("-");
            }
            if (transferOfPower1.getPowerInstallFee().equals("-")){//摊入费用
                if (transferOfPower1.getPowerBuildFee()!=null){
                    standInFee = Double.valueOf(transferOfPower1.getPowerBuildFee())+eqmValue;
                    standInFee = Double.valueOf(transferOfPower1.getPowerBuildFee())/standInFee;
                    if (erpCredit.getOtherTotalFee()!=null){
                        standInFee = standInFee*erpCredit.getOtherTotalFee();//乘其他费用合计
                    }
                    transferOfPower1.setPowerStandInFee(decimalFormat.format(standInFee));//添加摊入费用
                    powerDeliveredAssets+=standInFee;//交付使用资产价值
                    standInFeeAll+=standInFee;//摊入费用合计
                }
            }else {
                //摊入费用
                standInFee = Double.valueOf(transferOfPower1.getPowerInstallFee())+eqmValue;
                standInFee = Double.valueOf(transferOfPower1.getPowerInstallFee())/standInFee;
                if (erpCredit.getOtherTotalFee()!=null){
                    standInFee = standInFee*erpCredit.getOtherTotalFee();//乘其他费用合计
                }
                transferOfPower1.setPowerStandInFee(decimalFormat.format(standInFee));//添加摊入费用
                powerDeliveredAssets+=standInFee;//交付使用资产价值
                standInFeeAll+=standInFee;//摊入费用合计
            }
            //添加交付使用资产价值
            if (!transferOfPower1.getPowerInstallFee().equals("-")||null!=transferOfPower1.getPowerBuildFee()){
                transferOfPower1.setPowerDeliveredAssets(decimalFormat.format(powerDeliveredAssets));
                powerDeliveredAssetsAll+=powerDeliveredAssets;//交付费用合计
            }
            transferOfPower1s.add(transferOfPower1);//添加到集合中
        }
        transferOfPower1 = new TransferOfPower1();
        //添加 合计金额
        transferOfPower1.setPowerName(POWER_HJ);
        transferOfPower1.setPowerTenKvLineLength(decimalFormat.format(powerTenKvLineLengthAll));
        transferOfPower1.setPowerBuildFee(decimalFormat.format(buildFeeAll));
        transferOfPower1.setPowerInstallFee(decimalFormat.format(installFeeAll));
        transferOfPower1.setPowerStandInFee(decimalFormat.format(standInFeeAll));
        transferOfPower1.setPowerDeliveredAssets(decimalFormat.format(powerDeliveredAssetsAll));
        transferOfPower1s.add(transferOfPower1);
        return transferOfPower1s;
    }

    /**
     * 移交资产—配电网资产一览表(设备)
     * @param erpCredits
     * @return
     */
    public static List<TransferOfPower2> getTransferOfPower2(List<ErpCredit> erpCredits){
        DecimalFormat decimalFormat   = new DecimalFormat("#0.00");
        DecimalFormat decimalFormat1   = new DecimalFormat("#0");
        List<TransferOfPower2> transferOfPower2s =  new ArrayList<TransferOfPower2>();//得到设备表集合
        List<ErpCreditEquipment> erpCreditChild1s = null;//定义设备 费对象
        TransferOfPower2 transferOfPower2 = null;//定义设备表对象

        Double materialTotal = 0.0;//材料费总计

        Double powerValue = 0.0;
        Double eqmFtIntalls = 0.0;//获取分摊安装费
        Double powerInstallFee = 0.0;//安装费用(线路)
        Double powerEqmMater=0.0;//物料材料合计
        Double powerStandInFee = 0.0;//摊入费用
        Double powerDeliveredAssets=0.0;//交付使用资产价值
        //合计
        Double eqmNumbersAll = 0.0;//数量合计
        Double powerValueAll=0.0;//价值合计
        Double powerStandInFeeAll=0.0;//摊入费用
        Double powerDeliveredAssetsAll=0.0;//交付使用资产价值
        for (ErpCredit erpCredit:erpCredits){
            //材料费合计
            materialTotal = getErpCreditMaterial(erpCredit);//得到材料费

            erpCreditChild1s = erpCredit.getErpCreditChild1s();//得到设备费集合

            //得到安装费用
            if (null!=erpCredit.getConsInstallFee()&&erpCredit.getTenKvModel()!=null){ //安装费（x线路表）
                powerInstallFee = erpCredit.getConsInstallFee()+materialTotal;
            }
            if (null!=erpCredit.getConsBuildingFee()&&erpCredit.getTenKvModel()!=null){
                powerInstallFee = erpCredit.getConsBuildingFee()+materialTotal;//赋值powerInstallfe为建筑费
            }
            if (null!=erpCreditChild1s && erpCreditChild1s.size()>=0){//
//                for (ErpCreditEquipment erpCreditChild11:erpCreditChild1s){//循环集合
//                    if (null!=erpCreditChild11.getEqmNumbers()){//当前项目定义号所有的台数合计
//                        eqmNumbers+=erpCreditChild11.getEqmNumbers();
//                    }
//                }
                for (ErpCreditEquipment erpCreditChild1:erpCreditChild1s){
                    eqmFtIntalls = 0.0;//定义台数初始值
                    powerDeliveredAssets=0.0;//交付使用价值初始值
                    powerEqmMater=0.0;//物料材料合计
                    powerValue = 0.0;//赋予初始值
                    powerStandInFee=0.0;//赋予初始值
                    transferOfPower2 = new TransferOfPower2();//定义设备表对象
                    transferOfPower2.setPowerId(erpCredit.getItemId());//赋值项目定义编号
                    transferOfPower2.setPowerName(erpCredit.getItemName());//添加项目名称
                    transferOfPower2.setPowerArea("-");//线路起始地带
                    transferOfPower2.setPowerDepartment(ExportUtil1.POWER_DEPARTMENT);//添加保管
                    if (null!=erpCredit.getConsInstallFee()&& null != erpCreditChild1.getEqmBookedFee1()){//得到分摊后安装费
                        eqmFtIntalls=erpCredit.getConsTotalFee()/erpCreditChild1.getEqmBookedFee1();
                        eqmFtIntalls = eqmFtIntalls*erpCreditChild1.getEqmBookedFee1();
                    }
                    if (null!=erpCreditChild1.getEqmNumbers()){//得到配变数量（erp账户中设备台数）
                        transferOfPower2.setPowerNumber(decimalFormat1.format(erpCreditChild1.getEqmNumbers()));
                        eqmNumbersAll+=erpCreditChild1.getEqmNumbers();//配电数量合计金额累加
                    }
                    if (null!=erpCreditChild1.getEqmUnit()){//计量单位
                        transferOfPower2.setPowerUnit(erpCreditChild1.getEqmUnit());
                    }
                    //配电容量
                    transferOfPower2.setPowerCapacity(erpCreditChild1.getEqmMaterialDetails1());
                    //设备价值
                    if (null!=erpCreditChild1.getEqmBookedFee1()){//如果入账金额不为空
                        if (null!=transferOfPower2.getPowerCapacity()&& null == erpCredit.getTenKvModel()){
                            powerValue=erpCreditChild1.getEqmBookedFee1()+eqmFtIntalls;//价值合计 设备入账金额+安装费
                            transferOfPower2.setPowerValue(decimalFormat.format(powerValue));//赋值设备价值
                        }else {
                            powerValue=erpCreditChild1.getEqmBookedFee1();//价值合计 设备入账金额
                            transferOfPower2.setPowerValue(decimalFormat.format(powerValue));//赋值设备价值
                        }
                        powerDeliveredAssets +=powerValue;//交付使用价值合计
                        powerValueAll+=powerValue;//合计//设备价值合计
                    }else {
                        powerValue=erpCreditChild1.getEqmBookedFee1();
                        transferOfPower2.setPowerValue(decimalFormat.format(powerValue));
                        powerDeliveredAssets+=powerValue;
                        powerValueAll+=powerValue;//合计
                    }
                    //计算摊入费用
                    powerEqmMater = Double.parseDouble(transferOfPower2.getPowerValue())+powerInstallFee;//设备价值加上安装费设备价值
                    if (erpCredit.getOtherTotalFee()!=null){
                        powerStandInFee=Double.parseDouble(transferOfPower2.getPowerValue())/powerEqmMater*erpCredit.getOtherTotalFee();
                    }else {
                        powerStandInFee =0.0;
                    }
                    if (null==erpCredit.getTenKvModel()){
                        powerStandInFee = erpCredit.getOtherTotalFee();
                    }
                    transferOfPower2.setPowerStandInFee(decimalFormat.format(powerStandInFee));//赋值设备分摊费用
                    if (null!=erpCredit.getConsInstallFee()){
                        powerDeliveredAssets+=powerStandInFee;//交付使用费用累加
                        powerStandInFeeAll+=powerStandInFee;//分摊费用累加W
                    }else {
                        transferOfPower2.setPowerStandInFee("-");//赋值设备分摊费用
                    }

                    //添加资产类别
                    if (transferOfPower2.getPowerCapacity().contains(POWER_BDZ)){
                        transferOfPower2.setPowerAssetClass(POWER_BDZCOUNT);
                    }
                    if (transferOfPower2.getPowerCapacity().contains(POWER_BOXBDZ)){
                        transferOfPower2.setPowerAssetClass(POWER_BOXCOUNT);
                    }
                    if (transferOfPower2.getPowerCapacity().contains(POWER_HGW)){
                        transferOfPower2.setPowerAssetClass(POWER_HGWCOUNT);
                    }
                    if (transferOfPower2.getPowerCapacity().contains(POWER_KGG)){
                        transferOfPower2.setPowerAssetClass(POWER_KGGCOUNT);
                    }
                    transferOfPower2.setPowerDeliveredAssets(decimalFormat.format(powerDeliveredAssets));//交付使用资产价值
                    powerDeliveredAssetsAll+=powerDeliveredAssets;
                    transferOfPower2s.add(transferOfPower2);
                }
            }
        }
        transferOfPower2 = new TransferOfPower2();
        transferOfPower2.setPowerName(POWER_HJ);
        transferOfPower2.setPowerNumber(decimalFormat1.format(eqmNumbersAll));//配电数量合计
        transferOfPower2.setPowerValue(decimalFormat.format(powerValueAll));//计量价值合计
        transferOfPower2.setPowerStandInFee(decimalFormat.format(powerStandInFeeAll));//摊入费用合计
        transferOfPower2.setPowerDeliveredAssets(decimalFormat.format(powerDeliveredAssetsAll));//交付使用资产价值合计
        transferOfPower2s.add(transferOfPower2);
        return transferOfPower2s;
    }
    //概况表
    public static GeneralSituation getFeneraSituation(List<ErpCredit> erpCredits, List<MaintainData> maintainDataList){
        DecimalFormat decimalFormat   = new DecimalFormat("#0.00");
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy/MM/dd");
        GeneralSituation generalSituation = new GeneralSituation();
        Double lineLength=0.0;//线路长度
        Double tenKvLength=0.0;//其中：10kv线路
        Double fourKvLength=0.0;//400v及以下
        List<String> organDataList = new ArrayList<String>();//预算批准机关、日期、文号
        TreeSet<Date>  commencementDateSet =new TreeSet<Date>();//开工日期
        TreeSet<Date> completionDateSet = new TreeSet<Date>();//竣工时间
        Date beforeDate=null;
        Date endDate = null;
        String organData = "";//文号
        Double investmentBudget=0.0;//预算投资
        Double actualInvestment=0.0;//实际投资
        if (null!=erpCredits&&erpCredits.size()>0){
            for (ErpCredit erpCredit:erpCredits){
                //如果线路长度不为空
                if (null!=erpCredit.getTenKvLineLength()){
                    lineLength+=erpCredit.getTenKvLineLength();//得到线路长度（线路）
                }
                //其中：10kv线路
                if (null!=erpCredit.getTenKvItsLine()){
                    tenKvLength+=erpCredit.getTenKvItsLine();
                }
                //400kv
                if (null!=erpCredit.getTenKvItesFhvFollow()){
                    fourKvLength+=erpCredit.getTenKvItesFhvFollow();
                }
                //实际投资
                if (null!=erpCredit.getActualInvestment()){
                    actualInvestment+=erpCredit.getActualInvestment();
                }
            }
            generalSituation.setLineLength(decimalFormat.format(lineLength));
            generalSituation.setTenKvLength(decimalFormat.format(tenKvLength));
            generalSituation.setFourKvLength(decimalFormat.format(fourKvLength));
            generalSituation.setActualInvestment(decimalFormat.format(actualInvestment));
            generalSituation.setTransferAssets(decimalFormat.format(actualInvestment));
            generalSituation.setHasItsOwn(decimalFormat.format(actualInvestment));
        }
        if (null!=maintainDataList&&maintainDataList.size()>0){
            for (MaintainData maintainData:maintainDataList){
                if (null!=maintainData.getApprovalNumber()){//如果审批文号不为空
                    organDataList.add(maintainData.getApprovalNumber());
                }
                if (null!=maintainData.getStartDate()&&maintainData.getStartDate().toString().length()>0){
                    commencementDateSet.add(maintainData.getStartDate());
                }
                if (null!=maintainData.getEndDate()&&maintainData.getEndDate().toString().length()>0){
                    completionDateSet.add(maintainData.getEndDate());
                }
                investmentBudget+=maintainData.getDesignFee()+maintainData.getSupervisionFee()+maintainData.getPreliminaryWorkFee()
                        +maintainData.getDamages()+maintainData.getManagementFee()+maintainData.getBuildingFee()+maintainData.getInstallFee()
                        +maintainData.getEquipmentFee()+maintainData.getMaterialFee();
            }
            if (null!=organDataList&&organDataList.size()>0){
                //去重
//                for (int i = 0; i < organDataList.size(); i++) {
//                    for (int j = 0; j < organDataList.size(); j++) {
//                        if(i!=j&&organDataList.get(i)==organDataList.get(j)) {
//                            organDataList.remove(organDataList.get(j));
//                        }
//                    }
//                }
//                for(String str:organDataList){
//                    organData+=str+",";
//                }
                generalSituation.setOrganDataNumber(organDataList.get(1));
            }
            if (null!=commencementDateSet&&commencementDateSet.size()>0){
                generalSituation.setCommencementDate(sdf.format(commencementDateSet.first()));
            }
            if (null!=completionDateSet&&completionDateSet.size()>0){
                generalSituation.setCompletionDate(sdf.format(completionDateSet.last()));
            }
            generalSituation.setInvestmentBudget(decimalFormat.format(investmentBudget));
        }
        return generalSituation;
    }
    //资产总表
    public static List<TheAssetsTotal> getTheAssetsTotal(List<ErpCredit> erpCredits){
        DecimalFormat decimalFormat   = new DecimalFormat("#0.00");
        List<TheAssetsTotal> theAssetsTotals = new ArrayList<TheAssetsTotal>();
        TheAssetsTotal theAssetsTotal1 = new TheAssetsTotal();
        TheAssetsTotal theAssetsTotal2 = new TheAssetsTotal();
        TheAssetsTotal theAssetsTotal3 = new TheAssetsTotal();
        Double buildProject=0.0;//建筑工程
        Double intallProject=0.0;//安装工程费
        Double equipmentValue=0.0;//设备价值
        Double costSharing=0.0;//分摊费用
        Double deliveryCostValue=0.0;//交付使用资产价值
        Double equipmentValue1=0.0;//设备价值
        Double costSharing1=0.0;//分摊费用
        Double deliveryCostValue1=0.0;//交付使用资产价值
        List<TransferOfPower1> transferOfPower1s = getTransFerPower1(erpCredits);//得到线路表
        List<TransferOfPower2> transferOfPower2s = getTransferOfPower2(erpCredits);//得到设备表
        for (int i = 0; i < transferOfPower1s.size(); i++) {
            if (i!=transferOfPower1s.size()-1){
                if (null!= transferOfPower1s.get(i).getPowerBuildFee()){//建筑
                    buildProject+=Double.parseDouble(transferOfPower1s.get(i).getPowerBuildFee());
                }
                if (null!=transferOfPower1s.get(i).getPowerInstallFee()&&!transferOfPower1s.get(i).getPowerInstallFee().equals("-")){
                    intallProject+=Double.parseDouble(transferOfPower1s.get(i).getPowerInstallFee());
                }
                if (null!=transferOfPower1s.get(i).getPowerStandInFee()&&!transferOfPower1s.get(i).getPowerStandInFee().equals("-")){//分摊费用
                    costSharing+=Double.parseDouble(transferOfPower1s.get(i).getPowerStandInFee());
                }
                if (null!=transferOfPower1s.get(i).getPowerDeliveredAssets()){
                    deliveryCostValue+=Double.parseDouble(transferOfPower1s.get(i).getPowerDeliveredAssets());
                }
            }
        }
        theAssetsTotal1.setBuildProject(decimalFormat.format(buildProject));//添加建筑费
        theAssetsTotal1.setIntallProject(decimalFormat.format(intallProject));//添加设备费
        theAssetsTotal1.setCostSharing(decimalFormat.format(costSharing));
        theAssetsTotal1.setDeliveryCostValue(decimalFormat.format(deliveryCostValue));
        for (int i = 0; i < transferOfPower2s.size(); i++) {
            if (i!=transferOfPower2s.size()-1){
                if (null!=transferOfPower2s.get(i).getPowerValue()){//设备价值
                    equipmentValue1+=Double.parseDouble(transferOfPower2s.get(i).getPowerValue());
                }
                if (null!=transferOfPower2s.get(i).getPowerStandInFee()){
                    costSharing1+=Double.parseDouble(transferOfPower2s.get(i).getPowerStandInFee());
                }
                if (null!=transferOfPower2s.get(i).getPowerDeliveredAssets()){
                    deliveryCostValue1 += Double.parseDouble(transferOfPower2s.get(i).getPowerDeliveredAssets());
                }
            }
        }
        theAssetsTotal2.setEquipmentValue(decimalFormat.format(equipmentValue1));
        theAssetsTotal2.setCostSharing(decimalFormat.format(costSharing1));
        theAssetsTotal2.setDeliveryCostValue(decimalFormat.format(deliveryCostValue1));
        //添加三
        theAssetsTotal3.setBuildProject(decimalFormat.format(buildProject));
        theAssetsTotal3.setIntallProject(decimalFormat.format(intallProject));
        theAssetsTotal3.setEquipmentValue(decimalFormat.format(equipmentValue1));
        theAssetsTotal3.setCostSharing(decimalFormat.format(costSharing+costSharing1));
        theAssetsTotal3.setDeliveryCostValue(decimalFormat.format(deliveryCostValue+deliveryCostValue1));
        theAssetsTotals.add(theAssetsTotal3);
        theAssetsTotals.add(theAssetsTotal1);
        theAssetsTotals.add(theAssetsTotal2);
        return theAssetsTotals;
    }
    //竣 工 工 程 财 务 决 算 表
    public static MCompletionProject getMCompletionProject(List<ErpCredit> erpCredits, List<MaintainData> maintainDataList){
        DecimalFormat decimalFormat   = new DecimalFormat("#0.00");
        MCompletionProject mCompletionProject = new MCompletionProject();
        Double appropriatedFunds=0.0;//上级拨入资金
        Double vatDeduction=0.0;//、抵扣增值税
        Double fixedAssets=0.0;//交付使用固定资产
        Double transferAssets=0.0;//移交资产合计
        Double completed=0.0;//含税投资完成
        for (ErpCredit erpCredit:erpCredits){
            if (null!=erpCredit.getActualInvestment()){
                fixedAssets+=erpCredit.getActualInvestment();
                transferAssets+=erpCredit.getActualInvestment();
            }
            if (null!=erpCredit.getTheInputTax()){
                vatDeduction+=erpCredit.getTheInputTax();
            }
        }
        completed=transferAssets+vatDeduction;
        for (MaintainData maintainData:maintainDataList){
            appropriatedFunds+=maintainData.getDesignFee()+maintainData.getSupervisionFee()+maintainData.getPreliminaryWorkFee()
                    +maintainData.getDamages()+maintainData.getManagementFee()+maintainData.getBuildingFee()+maintainData.getInstallFee()
                    +maintainData.getEquipmentFee()+maintainData.getMaterialFee();
        }
        mCompletionProject.setTransferAssets(decimalFormat.format(transferAssets));
        mCompletionProject.setAppropriatedFunds(decimalFormat.format(appropriatedFunds));
        mCompletionProject.setFixedAssets(decimalFormat.format(fixedAssets));
        mCompletionProject.setVatDeduction(decimalFormat.format(vatDeduction));
        mCompletionProject.setCompleted(decimalFormat.format(completed));
        return mCompletionProject;
    }

    //材料费合计
    public  static Double getErpCreditMaterial(ErpCredit erpCredit){
        Double materialTotal = 0.0;
        List<ErpCreditMaterial> erpCreditMaterials = erpCredit.getErpCreditChild2s();//材料费
        if (null!=erpCreditMaterials&& erpCreditMaterials.size()>0){//得到材料费合计
            for (ErpCreditMaterial erpCreditMaterial:erpCreditMaterials){
                materialTotal+=erpCreditMaterial.getMtlBookedFee2();
            }
        }
        return materialTotal;
    }
}
