/**
 * Copyright &copy; 2015-2020 <a href="http://www.jeeplus.org/">JeePlus</a> All rights reserved.
 */
package com.jeeplus.modules.sg.managementcenter.activiti.web;

import com.jeeplus.modules.sys.entity.Office;
import com.jeeplus.modules.act.entity.Act;

import java.net.URLDecoder;
import java.util.Date;
import com.jeeplus.modules.sys.entity.User;

import com.google.common.collect.Maps;
import com.jeeplus.common.json.AjaxJson;
import com.jeeplus.common.utils.DateUtils;
import com.jeeplus.common.utils.StringUtils;
import com.jeeplus.common.utils.excel.ImportExcel;
import com.jeeplus.core.persistence.Page;
import com.jeeplus.core.web.BaseController;
import com.jeeplus.modules.act.service.ActProcessService;
import com.jeeplus.modules.act.service.ActTaskService;
import com.jeeplus.modules.sg.managementcenter.activiti.entity.Construction;
import com.jeeplus.modules.sg.managementcenter.activiti.entity.Disclose;
import com.jeeplus.modules.sg.managementcenter.activiti.entity.UploadImages;
import com.jeeplus.modules.sg.managementcenter.activiti.service.ConstructionService;
import com.jeeplus.modules.sg.managementcenter.activiti.service.DiscloseService;
import com.jeeplus.modules.sg.managementcenter.activiti.service.UploadImagesService;
import com.jeeplus.modules.sg.managementcenter.activiti.utils.myActiviUtils;
import com.jeeplus.modules.sys.utils.UserUtils;
import com.jeeplus.modules.test.pic.entity.TestPic;
import org.activiti.engine.*;
import org.activiti.engine.delegate.Expression;
import org.activiti.engine.impl.RepositoryServiceImpl;
import org.activiti.engine.impl.persistence.entity.ExecutionEntity;
import org.activiti.engine.impl.persistence.entity.ProcessDefinitionEntity;
import org.activiti.engine.impl.pvm.PvmActivity;
import org.activiti.engine.impl.pvm.PvmTransition;
import org.activiti.engine.impl.pvm.process.ActivityImpl;
import org.activiti.engine.impl.task.TaskDefinition;
import org.activiti.engine.repository.ProcessDefinition;
import org.activiti.engine.runtime.ProcessInstance;
import org.activiti.engine.task.Task;
import org.apache.poi.ss.usermodel.Row;
import org.apache.shiro.authz.annotation.Logical;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.validation.ConstraintViolationException;
import java.util.List;
import java.util.Map;
import java.util.Set;

/**
 * 施工交底Controller
 * @author
 * @version 2019-11-08
 */
@Controller
@RequestMapping(value = "${adminPath}/managementcenter/divide")

public class DivideController extends BaseController {

	@Autowired
	private ConstructionService constructionService;
	@Autowired
	private ActProcessService actProcessService;
	@Autowired
	private ActTaskService actTaskService;
	@Autowired
	private DiscloseService discloseService;
	@Autowired
	private UploadImagesService uploadImagesService;
	@Autowired
	private TaskService taskService;
	@Autowired
	private RuntimeService runtimeService;
	@ModelAttribute
	public Construction get(@RequestParam(required=false) String id) {
		Construction entity = null;
		if (StringUtils.isNotBlank(id)){
			entity = constructionService.get(id);
		}
		if (entity == null){
			entity = new Construction();
		}
		return entity;
	}



//	/**
//	 * 文件管理列表数据
//	@ResponseBody
//	@RequestMapping(value = "data")
//	public Map<String, Object> data(UploadImages uploadImages, HttpServletRequest request, HttpServletResponse response, Model model) {
//		Page<UploadImages> page = uploadImagesService.findPage(new Page<UploadImages>(request, response), uploadImages);
//		return getBootstrapData(page);
//	}*/


	

	/**
	 * 查看，增加，编辑请假申请表单页面
	 */
	@RequestMapping(value = "form/{mode}")
	public String form(@PathVariable String mode, Construction construction, Model model) {

		model.addAttribute("construction", construction);
		if("audit".equals(mode)){
			return "modules/sg/managementcenter/activiti/divideAudit";
		}else{//audit
			return "modules/sg/managementcenter/activiti/divideForm";
		}
//		return "modules/sg/managementcenter/activiti/constructionForm";
	}

	/**
	 * 保存请假申请
	 */
	@ResponseBody
	@RequestMapping(value = "save")
	public AjaxJson save(Disclose disclose, Model model) throws Exception{
		AjaxJson j = new AjaxJson();
		/**
		 * 后台hibernate-validation插件校验
		 */
		String errMsg = beanValidator(disclose);
		if (StringUtils.isNotBlank(errMsg)){
			j.setSuccess(false);
			j.setMsg(errMsg);
			return j;
		}


		/**
		 * 流程审批
		 */
		if (StringUtils.isBlank(disclose.getId())){
			//新增或编辑表单保存
			discloseService.save(disclose);//保存
			// 启动流程
			ProcessDefinition p = actProcessService.getProcessDefinition(disclose.getAct().getProcDefId());
			String title = disclose.getCurrentUser().getName()+"在"+ DateUtils.getDateTime()+"发起"+p.getName();
			actTaskService.startProcess(p.getKey(),  "xm_construction_clarificaiton", disclose.getId(), title);
			j.setMsg("发起流程审批成功!");
			j.getBody().put("targetUrl",  "/act/task/process/");
		}else{
			//新增或编辑表单保存
			discloseService.save(disclose);//保存
			disclose.getAct().setComment(("yes".equals(disclose.getAct().getFlag())?"[重新申请] ":"[销毁申请] "));
			// 完成流程任务
			Map<String, Object> vars = Maps.newHashMap();
			vars.put("reapply", "yes".equals(disclose.getAct().getFlag())? true : false);
			actTaskService.complete(disclose.getAct().getTaskId(), disclose.getAct().getProcInsId(), disclose.getAct().getComment(), disclose.getContent(), vars);
			j.setMsg("提交成功！");
			j.getBody().put("targetUrl",  "/act/task/todo/");
		}
		return j;
	}


	/**
	 * 导入交底结论
	 */
//    @RequiresPermissions("modules:sg:information:information:import")
	@ResponseBody
	@RequestMapping(value = "importConclusion")
	public AjaxJson importConclusion(@RequestParam("file") MultipartFile file, HttpServletResponse response, HttpServletRequest request, String procInsId,String projectName) {
		AjaxJson j = new AjaxJson();
		try {
			int successNum = 0;
			int failureNum = 0;
			StringBuilder failureMsg = new StringBuilder();
			ImportExcel ei = new ImportExcel(file, 1, 0);
			int lastDataRowNum = ei.getLastDataRowNum();
			Disclose disclose = new Disclose();
			for (int i = 1; i < lastDataRowNum; i++) {
				Row row = ei.getRow(i);
				disclose.setProcInsId(procInsId);
				projectName = URLDecoder.decode(projectName, "UTF-8");
				disclose.setConId(projectName);
				disclose.setChannel(ei.getCellValue(row, 0 ).toString());
				disclose.setCapacity(ei.getCellValue(row, 1 ).toString());
				disclose.setSceneSize(ei.getCellValue(row, 2 ).toString());
				disclose.setCapacitySize(ei.getCellValue(row, 3 ).toString());
				disclose.setHiddenDanger(ei.getCellValue(row, 4 ).toString());
				disclose.setInfluenceConstruction(ei.getCellValue(row, 5 ).toString());
				disclose.setProjectRepetition(ei.getCellValue(row, 6 ).toString());
				disclose.setImplemented(ei.getCellValue(row, 7 ).toString());
				disclose.setTransformer(ei.getCellValue(row, 8 ).toString());
				disclose.setLineName(ei.getCellValue(row, 9 ).toString());
				disclose.setQuantities(ei.getCellValue(row, 10).toString());
				disclose.setRodNumber(ei.getCellValue(row, 11).toString());
				disclose.setAdministrationType(ei.getCellValue(row, 12).toString());
				disclose.setPoliticalProblem(ei.getCellValue(row, 13).toString());
				disclose.setPrecondition(ei.getCellValue(row, 14).toString());
				disclose.setPlacementMode(ei.getCellValue(row, 15).toString());
				disclose.setProductionDate(ei.getCellValue(row, 16).toString());
				disclose.setIntegrateModule(ei.getCellValue(row, 17).toString());
				disclose.setNeedReplace(ei.getCellValue(row, 18).toString());
				disclose.setOverallTransformation(ei.getCellValue(row, 19).toString());
			}
			try {
				discloseService.save(disclose);
				successNum++;
			} catch (ConstraintViolationException ex) {
				failureNum++;
			} catch (Exception ex) {
				failureNum++;
			}
			if (failureNum > 0) {
				failureMsg.insert(0, "，失败 " + failureNum + " 条票务代理记录。");
			}
			j.setMsg("已成功导入 " + successNum + " 条票务代理记录" + failureMsg);
		} catch (Exception e) {
			j.setSuccess(false);
			j.setMsg("导入票务代理失败！失败信息：" + e.getMessage());
		}
		return j;
	}

}