/**
 * Copyright &copy; 2015-2020 <a href="http://www.jeeplus.org/">JeePlus</a> All rights reserved.
 */
package com.jeeplus.modules.sg.managementcenter.materialproject.service;

import com.jeeplus.core.persistence.Page;
import com.jeeplus.core.service.CrudService;
import com.jeeplus.modules.sg.managementcenter.materialinfo.service.MaterialInfoService;
import com.jeeplus.modules.sg.managementcenter.materialproject.entity.MaterialProject;
import com.jeeplus.modules.sg.managementcenter.materialproject.mapper.MaterialProjectMapper;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;


@Service
@Transactional(readOnly = true)
public class MaterialProjectService extends CrudService<MaterialProjectMapper, MaterialProject> {
	@Autowired
	private MaterialProjectMapper materialProjectMapper;
	@Autowired
	private MaterialInfoService materialInfoService;

	public MaterialProject get(String id) {
		return super.get(id);
	}
	
	public List<MaterialProject> findList(MaterialProject materialProject) {
		return super.findList(materialProject);
	}

	public List<MaterialProject> findBatch(){
		return materialProjectMapper.findBatch();
	}

	public List<MaterialProject> findByList(List<MaterialProject> list){
		return materialProjectMapper.findByList(list);
	}
	
	public Page<MaterialProject> findPage(Page<MaterialProject> page, MaterialProject materialProject) {
		return super.findPage(page, materialProject);
	}
	
	@Transactional(readOnly = false)
	public void save(MaterialProject materialProject) {
		super.save(materialProject);
	}
	
	@Transactional(readOnly = false)
	public void delete(MaterialProject materialProject) {
		super.delete(materialProject);
		materialInfoService.deleteByPro(materialProject.getReserveProjectName());
	}
	
}