package com.jeeplus.modules.sg.managementcenter.project.util;
import com.jeeplus.modules.sg.managementcenter.project.entity.Project;
import org.apache.commons.lang3.StringUtils;
import org.apache.poi.ss.usermodel.Row;

import java.util.ArrayList;
import java.util.List;
import java.util.UUID;

public  class ProExcelInfo {
    /**
     * 获取表格数据
     * @param importUtil
     * @return List<ErpAccount> 导入表格数据
     */
    public static List<Project> getProjectUtil(ImportUtil importUtil)  {
        int lastRow = importUtil.getLastDataRowNum();
        List<Project> list = new ArrayList<Project>();
        Project project = null;
        String costEstimate="";//费用估算
        for(int i=2; i<lastRow;i++){
            project = new Project();
            Row row = importUtil.getRow(i);
            String requireCode = (String) importUtil.getCellValue(row,5);
            if(StringUtils.isNotBlank(requireCode)) {
                project.setRequireName(requireCode);
                project.setType((String)importUtil.getCellValue(row,1));//类型
                project.setDemandUnit((String)importUtil.getCellValue(row,2));//需求提出单位
                project.setBdzName((String)importUtil.getCellValue(row,3));//变电站名称
                project.setLineName((String)importUtil.getCellValue(row,4));//线路名称
                project.setProjectId((String)importUtil.getCellValue(row,6));//工程编号
                project.setProjectName((String)importUtil.getCellValue(row,7));//项目名称
                project.setProjectNumber((String)importUtil.getCellValue(row,8));//项目定义号
                project.setProjectManageRole((String)importUtil.getCellValue(row,9));//项目经理角色
                project.setConstructionUnit((String)importUtil.getCellValue(row,10));//施工单位
                project.setConstructionUnitRole((String)importUtil.getCellValue(row,11));//施工单位角色
                project.setClarificaitonType((String)importUtil.getCellValue(row,12));//交底类型
                project.setBulidClassificationResons((String)importUtil.getCellValue(row,13));//建设理由分类
                project.setBulbidResons((String)importUtil.getCellValue(row,14));//建设理由
                project.setAsicEquipment((String)importUtil.getCellValue(row,15));//设备基本状况
                project.setRunTheClass((String)importUtil.getCellValue(row,16));//运行班
                project.setProjectTeam((String)importUtil.getCellValue(row,17));//项目组
                costEstimate = (String) importUtil.getCellValue(row,18);
                if (null!=costEstimate&&!costEstimate.equals("")){
                    project.setCostEstimate(Double.parseDouble(costEstimate));//费用估算
                }
                project.setWhetherRheUpwind((String)importUtil.getCellValue(row,19));//是否迎风期度夏项目
                project.setSureDaDate((String)importUtil.getCellValue(row,20));//确定下达时间
                project.setTextRemark((String)importUtil.getCellValue(row,21));//备注
                project.setPowerLine((String)importUtil.getCellValue(row,22));//停电线路
                project.setPowerScope((String)importUtil.getCellValue(row,23));//停电范围
                project.setProjectType((String)importUtil.getCellValue(row,24));//项目类型
                project.setPowerFlagPackage((String)importUtil.getCellValue(row,25));//是否为停电打包项目
                project.setPreliminaryJudgment((String)importUtil.getCellValue(row,26));//证处初步判断
                project.setFlagCivilEngineering((String)importUtil.getCellValue(row,27));//是否含土建
                project.setSteelTubePole((String)importUtil.getCellValue(row,28));//钢管杆基础类型
                project.setFlagApprovalPlanning((String)importUtil.getCellValue(row,29));//是否需要规划报批
                project.setEquCreateType((String)importUtil.getCellValue(row,30));//设备改造类型
                project.setEquCreateSize((String)importUtil.getCellValue(row,31));//间隔数
                project.setFlagNewEquName((String)importUtil.getCellValue(row,32));//是否新设备命名
                project.setIncludeBdzNews((String)importUtil.getCellValue(row,33));//是否含变电站新闻格投运
                project.setFlagNoElectrical((String)importUtil.getCellValue(row,34));//是否非射电电气施工
                project.setDrawingsWork((String)importUtil.getCellValue(row,35));//图纸标注的带点作业情况
                project.setFlagAutomation((String)importUtil.getCellValue(row,36));//是否含自动化
                project.setTwoAndThreeRemote((String)importUtil.getCellValue(row,37));//二遥或三
                project.setPhoneStyle((String)importUtil.getCellValue(row,38));//通信方式
                project.setStayOpenArea((String)importUtil.getCellValue(row,39));//柱开集中或就业地
                project.setRingNetworkCabinet((String)importUtil.getCellValue(row,40));//环网柜
                project.setStationDtu((String)importUtil.getCellValue(row,41));//站房dtu
                project.setStatus("0");
                list.add(project);
            }
        }
        return list;
    }

    /**
     * 生成随机数
     * @return
     */
    public static String getStatus(){
        int machineId = 1;
        int hashCodeV = UUID.randomUUID().toString().hashCode();
        if (hashCodeV<0){
            hashCodeV=-hashCodeV;
        }
        return  (machineId+String.format("%015d",hashCodeV));
    }
}
